#define HASH_DELAY 400


/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS3 libraries and device drivers.
// This will create a <projectname>.DL3 file, which you can copy to 
// your VS1005 Developer Board's system disk's SYS subdirectory.

// If init(), main() or fini() are not needed, remove them from the solution.
// There's no need to have any unneeded functions in the library.

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <string.h>
#include <timers.h>

#include <consolestate.h>

char oldcmd[256];
char tabfn[128];
u_int16 tabstate = 0;

ioresult main(char *cmdLine) {
	char *p = cmdLine;
	int i=0;

	memcpy(oldcmd, cmdLine, 256);
	// detect split string and unsplit.
	do {i++;} while (oldcmd[i] != 0); 
	if (oldcmd[i+1]) {
		oldcmd[i] = ' ';
	}
	memset(p,0,255);		
	
	appFlags &= ~(APP_FLAG_QUIT | APP_FLAG_RAWTTY);

	if (appFlags & APP_FLAG_ECHO) {
		printf("%s>", currentDirectory);
	} else {
		printf("#\n", appFlags);
	}
	
	while(1) {
		char c = fgetc(vo_stdin);
		//if (c<' ') {
		//	printf("[%x]",c);
		//}
		if (c==0x1b) {
			//printf("[Esc]");
			if (fgetc(vo_stdin) != 0x5b) continue;
			c = fgetc(vo_stdin);
			if (c=='A') goto prevcmd;
			continue;
		} else if (c==0x9) {
			static char *b2;
			static char *b;
			//printf("#1"); Delay(HASH_DELAY); printf("\x8\x8");
			if (tabstate==0) {
				//printf("#2"); Delay(HASH_DELAY); printf("\x8\x8");
				b = p;
				while ((b[-1]!=' ') && (b[-1]!=':') && (b[-1]!='/') && (b[-1]!='\\') && (b > cmdLine)) {
					b--;
				}
				b2 = b;
				b = p;
				while ((b[-1]!=' ') && (b > cmdLine)) {
					b--;
				}		
				if ((b2==cmdLine) && (b==cmdLine)) {
					sprintf(tabfn,"s:sys/%s*.dl3", b);					
				} else {
					sprintf(tabfn, "%s*", b);
				}
			}
			{
				char m[8];
				static char ident[128];
				FILE *f;
				tryagain:
				sprintf(m,"rb#%d",tabstate);
				tabstate++;
				f = fopen(tabfn, m);
				//printf("#3"); Delay(HASH_DELAY); printf("\x8\x8");
				//printf("(%s)(%s)",tabfn,m); Delay(1000);
				if (f) {
					//printf("#4"); Delay(HASH_DELAY); printf("\x8\x8");

					strcpy(b2, f->Identify(f,NULL,0));
					if ((b2==cmdLine) && (b==cmdLine)) {
						char *c = cmdLine;
						while (*c) {
							if (*c=='.') {
								char *d = &cmdLine[255];
								while(d>=c) {
									*d--=0;
								}
								break;
							}
							c++;
						}
					}
					p = cmdLine+strlen(cmdLine);
					if (appFlags & APP_FLAG_ECHO) {
						printf("\r%s>%s\x1b[0K",currentDirectory,cmdLine);
					}
					fclose(f);
				} else {
					//printf("#5"); Delay(HASH_DELAY); printf("\x8\x8");

					if (tabstate!=1) {
						//printf("#6"); Delay(HASH_DELAY); printf("\x8\x8");

						tabstate=0;
						goto tryagain;
					}
				}
			}

			continue;
		} else {
			tabstate = 0;
		
			if (c==0x01) {
				prevcmd:
				if (appFlags & APP_FLAG_ECHO) {
				  	printf("\r%s>%s",currentDirectory,oldcmd);
				}
				strcpy(cmdLine,oldcmd);
				p = cmdLine+strlen(cmdLine);
				continue;			
			} else if ((c==0xd) || (c==0xa)) {
				goto finally;
			} else if (c==8 || c==0x7f) {
				//printf("(%p)(%p)",p,cmdLine); Delay(500);
				if (p>cmdLine) {
					if (appFlags & APP_FLAG_ECHO) {
						*--p=0;
						printf("%c[1D",27);
						printf("%c[0K",27);
					}
				} else {
					//printf("#####");
				}
				continue;
			} else if (c>0x1b) {
				*p++ = c;
				if (appFlags & APP_FLAG_ECHO) {
				  fputc(c,vo_stdout);
				}
			} else {
				if (appFlags & APP_FLAG_ECHO) {
					int i;
					printf("<%02x>", c);
					Delay(300);
					for (i=0; i<4; i++) {
						printf("%c[1D",27);	
						printf("%c[0K",27);	
					}
				}
			}
		}
	}
	
 finally:
	*p = '\0';
	/* If command line is of format "x:", replace it with "cd x:" */
	if (p-cmdLine == 2 && cmdLine[1] == ':') {
	  sprintf(cmdLine, "cd %c:", cmdLine[0]);
	} else if (!strcmp(cmdLine, "..")) {
	  strcpy(cmdLine, "cd ..");
	}

	return S_OK;
}


void fini(void) {
	if (appFlags & APP_FLAG_ECHO) {
		printf("\n");
	} else {
		printf(":\n");
	}
}
