/* For free support for VSIDE, please visit www.vsdsp-forum.com */

/// \file liblist.c Print out a list of loaded libraries and free mem to stdout
/// \author Panu-Kristian Poiksalo, VLSI Solution Oy


#include <vo_stdio.h>
#include <volink.h>
#include <apploader.h>
#include <lcd.h>
#include <stdbuttons.h>
#include <string.h>

#include <ctype.h>


u_int16 LibNameCompare(u_int16 *lib, const char *name) {
	u_int16 *p = lib;
	u_int16 entries;
	u_int16 nSections;	
	entries = *p++;
	p += entries + 5;	
	nSections = *p++;
	p += nSections * 2 + 1;
	{
		char *s = (char*)p;
		while (1) {
			if (*name == 0) return 1;
			if (*s == 0) return 1;
			if (toupper(*s) != toupper(*name)) return 0;
			s++; name++;
		}
	}
}

void *FindLib(const char *name) {
	u_int16 i;
	for (i=0; i<MAX_LIB; i++) {
		if (loadedLib[i] && LibNameCompare(loadedLib[i],name)) return loadedLib[i];
	}
	return NULL;
}

void *main(char *parameters) {
	u_int16 i;
	u_int16 *lib;
	lib = FindLib(&parameters[1]);
	switch(parameters[0]) {
		case '?': {
			if (!lib) { 
				goto nolib;
			}
			printf("Lib %s is at %p.\n",lib);
			return lib;
			break;
		}
		
		case '-': {
			if (!lib) { 
				goto nolib;
			}
			lib[1] = 1;
			DropLibrary((void*)lib);			
			return NULL;
			break;
		}
		case '+': {
			char *program = parameters+1;	
			char* params=program;
			while(*params) {
				if(*params==' ') {
					*params=0;
					++params;
					break;
				}
				++params;
			}
			lib = LoadLibrary(program);
			if (lib[2+ENTRY_MAIN] != 0) { // If there is main function
				RunLoadedFunction(lib, ENTRY_MAIN, (int)params);
			}
			return lib;
		}



		default: {
			printf("Usage: DRIVER {+|-|?}libname\n");
			return 0;
		}
	}
	nolib:
	printf("Lib %s not found.\n",parameters+1);
	return 0;

	//printf("%s:%p\n",parameters,FindLib(parameters));
}
